Package org.eclipse.viatra.query.runtime.rete.single

## Class TimelyProductionNode

- java.lang.Object
- - org.eclipse.viatra.query.runtime.rete.network.BaseNode
  - - org.eclipse.viatra.query.runtime.rete.network.StandardNode
    - - org.eclipse.viatra.query.runtime.rete.single.AbstractUniquenessEnforcerNode
      - - org.eclipse.viatra.query.runtime.rete.single.TimelyUniquenessEnforcerNode
        - - org.eclipse.viatra.query.runtime.rete.single.TimelyProductionNode

- All Implemented Interfaces:
    `java.lang.Iterable<Tuple>`, `org.eclipse.viatra.query.runtime.rete.network.communication.timely.ResumableNode`, `IGroupable`, `NetworkStructureChangeSensitiveNode`, `Node`, `ProductionNode`, `Receiver`, `Supplier`, `Tunnel`

      public class TimelyProductionNode
      extends TimelyUniquenessEnforcerNode
      implements ProductionNode

  Differential dataflow implementation of the Production node, based on `TimelyUniquenessEnforcerNode`.
  Since:
    2.3
  No Instantiate:
    This class is not intended to be instantiated by clients.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected java.util.Map<java.lang.String,​java.lang.Integer>` | `posMapping` |

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.single.TimelyUniquenessEnforcerNode

      `group, memory`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.single.AbstractUniquenessEnforcerNode

      `identityMask, mailbox, memoryIdentityIndexer, memoryNullIndexer, nullMask, parents, specializedListeners, tupleWidth`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.network.StandardNode

      `childMailboxes, children`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.network.BaseNode

      `nodeId, reteContainer, tag, traceInfos`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TimelyProductionNode​(ReteContainer reteContainer, java.util.Map<java.lang.String,​java.lang.Integer> posMapping)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `acceptPropagatedTraceInfo​(TraceInfo traceInfo)` | accepts traceability info propagated to this node
    `java.util.Map<java.lang.String,​java.lang.Integer>` | `getPosMapping()` |
    `java.util.Iterator<Tuple>` | `iterator()` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.single.TimelyUniquenessEnforcerNode

      `getCurrentGroup, getIdentityIndexer, getNullIndexer, getResumableTimestamp, getTuples, instantiateMailbox, networkStructureChanged, pullInto, pullIntoWithTimeline, resumeAt, setCurrentGroup, update`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.single.AbstractUniquenessEnforcerNode

      `appendParent, assignTraceInfo, constructIndex, getMailbox, getParents, propagate, removeParent`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.network.StandardNode

      `appendChild, getChildMailboxes, getPulledContents, getReceivers, issueError, propagateUpdate, removeChild`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.network.BaseNode

      `getContainer, getNodeId, getTag, getTraceInfoPatternsEnumerated, getTraceInfos, setTag, toStringCore`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.rete.network.Node

      `assignTraceInfo, getCommunicationTracker, getContainer, getNodeId, getTag, getTraceInfos, setTag`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.rete.network.Receiver

      `appendParent, batchUpdate, getMailbox, getParents, removeParent, update`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.rete.network.Supplier

      `appendChild, constructIndex, getPulledContents, getPulledContents, getReceivers, pullInto, pullIntoWithTimeline, removeChild`

- - ### Field Detail

    - #### posMapping

          protected final java.util.Map<java.lang.String,​java.lang.Integer> posMapping

  - ### Constructor Detail

    - #### TimelyProductionNode

          public TimelyProductionNode​(ReteContainer reteContainer,
                                      java.util.Map<java.lang.String,​java.lang.Integer> posMapping)

  - ### Method Detail

    - #### getPosMapping

          public java.util.Map<java.lang.String,​java.lang.Integer> getPosMapping()

      Specified by:
        `getPosMapping` in interface `ProductionNode`
      Returns:
        the position mapping of this particular pattern that maps members of the tuple type to their positions

    - #### iterator

          public java.util.Iterator<Tuple> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<Tuple>`

    - #### acceptPropagatedTraceInfo

          public void acceptPropagatedTraceInfo​(TraceInfo traceInfo)

      Description copied from interface: `Node`
      accepts traceability info propagated to this node
      Specified by:
        `acceptPropagatedTraceInfo` in interface `Node`
      Overrides:
        `acceptPropagatedTraceInfo` in class `BaseNode`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `BaseNode`